import "Turbine"
import "Turbine.UI"
import "Turbine.UI.Lotro"
import "Turbine.Gameplay"
import "CajePlugins.HUDPlus.Controls"
import "CajePlugins.HUDPlus.OptionsMenu"
import "CajePlugins.HUDPlus.Meter"

--Use QuantityChanged() function to recognize when a depleted stack of objects in a quickslot has been replenished above 1

LoadTime = Turbine.Engine.GetLocalTime()
QSLoadTime = ( LoadTime + 120 )

HUDVis = "True"
HUDVischanging = "False"

MousePosX = Turbine.UI.Display.GetMouseX()
MousePosY = Turbine.UI.Display.GetMouseY()

LOADED = "FALSE"

MLastPot = "False"
PLastPot = "False"
PoLastPot = "False"
DLastPot = "False"
FLastPot = "False"
WLastPot = "False"

LFading = "True"
MWarnFlashOut = "False"
MWarnFlashIn = "False"
PWarnFlashOut = "False"
PWarnFlashIn = "False"

HUDPlus = Turbine.Plugin
version = Plugins["HUDPlus"]:GetVersion();
Turbine.Shell.WriteLine( "HUDPlus "..version.." by Caje" )

Player = Turbine.Gameplay.LocalPlayer.GetInstance();
StartMorale = Player:GetMorale()

function HUDPlus:SaveData()
	HUDPlusData = { }
	HUDPlusData.CritLevel = ( CriticalScroll:GetValue() / 100 )
	HUDPlusData.LowLevel = ( LowScroll:GetValue() / 100 )
	HUDPlusData.PCritLevel = ( PCriticalScroll:GetValue() / 100 )
	HUDPlusData.PLowLevel = ( PLowScroll:GetValue() / 100 )
	HUDPlusData.DLevel = ( DHitScroll:GetValue() )
	HUDPlusData.quickslots = quickslots
	HUDPlusData.Bars = Bars
	HUDPlusData.Meter = Meter
	HUDPlusData.Moralewarn = Moralewarn
	HUDPlusData.Powerwarn = Powerwarn
	HUDPlusData.PancD = PanCD
	HUDPlusData.BubCD = BubCD
	HUDPlusData.Text = Text
	HUDPlusData.CorruptionCD = CorruptionCD
	HUDPlusData.InterruptCD = InterruptCD
	HUDPlusData.DHitWarning = DHitWarning
	HUDPlusData.Cus1CD = Cus1CD
	HUDPlusData.Cus2CD = Cus2CD
	HUDPlusData.IndOnly = IndOnly
	HUDPlusData.MWopT = MWopT
	HUDPlusData.PWopT = PWopT
	HUDPlusData.DHopT = DHopT
	HUDPlusData.BopT = BopT
	HUDPlusData.MopT = MopT
	HUDPlusData.MData = MShortcut:GetData()
	HUDPlusData.PData = PShortcut:GetData()
	HUDPlusData.DData = DShortcut:GetData()
	HUDPlusData.WData = WShortcut:GetData()
	HUDPlusData.FData = FShortcut:GetData()
	HUDPlusData.PoData = PoShortcut:GetData()
	HUDPlusData.MType = MShortcut:GetType()
	HUDPlusData.PType = PShortcut:GetType()
	HUDPlusData.DType = DShortcut:GetType()
	HUDPlusData.WType = WShortcut:GetType()
	HUDPlusData.FType = FShortcut:GetType()
	HUDPlusData.PoType = PoShortcut:GetType()
	HUDPlusData.Panskill = Pantext:GetText()
	HUDPlusData.Corskill = Cortext:GetText()
	HUDPlusData.Intskill = Inttext:GetText()
	HUDPlusData.Bubskill = Bubtext:GetText()
	HUDPlusData.C1skill = C1text:GetText()
	HUDPlusData.C2skill = C2text:GetText()
	HUDPlusData.PanicCD = PanScroll:GetValue()
	HUDPlusData.CorCD = CorScroll:GetValue()
	HUDPlusData.IntCD = IntScroll:GetValue()
	HUDPlusData.BubbCD = BubScroll:GetValue()
	HUDPlusData.C1CD = C1Scroll:GetValue()
	HUDPlusData.C2CD = C2Scroll:GetValue()
	HUDPlusData.OOCcrit = OOCcrit
	HUDPlusData.Cus1CD = Cus1CD
	HUDPlusData.Cus2CD = Cus2CD
	HUDPlusData.MWarnX = MWarn:GetLeft()
	HUDPlusData.MWarnY = MWarn:GetTop()
	HUDPlusData.PWarnX = PWarn:GetLeft()
	HUDPlusData.PWarnY = PWarn:GetTop()
	HUDPlusData.DHitWarnX = DHitWarn:GetLeft()
	HUDPlusData.DHitWarnY = DHitWarn:GetTop()
	HUDPlusData.PanicCDX = PanicCD:GetLeft()
	HUDPlusData.PanicCDY = PanicCD:GetTop()
	HUDPlusData.BubbleCDX = BubbleCD:GetLeft()
	HUDPlusData.BubbleCDY = BubbleCD:GetTop()
	HUDPlusData.CorrCDX = CorrCD:GetLeft()
	HUDPlusData.CorrCDY = CorrCD:GetTop()
	HUDPlusData.IntCDX = IntCD:GetLeft()
	HUDPlusData.IntCDY = IntCD:GetTop()
	HUDPlusData.C1CDX = C1CD:GetLeft()
	HUDPlusData.C1CDY = C1CD:GetTop()
	HUDPlusData.C2CDX = C2CD:GetLeft()
	HUDPlusData.C2CDY = C2CD:GetTop()
	HUDPlusData.loadwithman = loadwithman

	HUDPlusData.MQSGX = MQSG:GetLeft()
	HUDPlusData.MQSGY = MQSG:GetTop()
	HUDPlusData.PQSGX = PQSG:GetLeft()
	HUDPlusData.PQSGY = PQSG:GetTop()
	HUDPlusData.DQSGX = DQSG:GetLeft()
	HUDPlusData.DQSGY = DQSG:GetTop()
	HUDPlusData.WQSGX = WQSG:GetLeft()
	HUDPlusData.WQSGY = WQSG:GetTop()
	HUDPlusData.FQSGX = FQSG:GetLeft()
	HUDPlusData.FQSGY = FQSG:GetTop()
	HUDPlusData.PoQSGX = PoQSG:GetLeft()
	HUDPlusData.PoQSGY = PoQSG:GetTop()
	HUDPlusData.MBarX = MBarWin:GetLeft()
	HUDPlusData.MBarY = MBarWin:GetTop()
	HUDPlusData.PBarX = PBarWin:GetLeft()
	HUDPlusData.PBarY = PBarWin:GetTop()
	HUDPlusData.MTWinX = MTWin:GetLeft()
	HUDPlusData.MTWinY = MTWin:GetTop()
	HUDPlusData.PTWinX = PTWin:GetLeft()
	HUDPlusData.PTWinY = PTWin:GetTop()
	HUDPlusData.TTWinX = TTWin:GetLeft()
	HUDPlusData.TTWinY = TTWin:GetTop()
	HUDPlusData.MeterBarX = MeterWin:GetLeft()
	HUDPlusData.MeterBarY = MeterWin:GetTop()

	Turbine.PluginData.Save( Turbine.DataScope.Character, "HUDPlus", HUDPlusData )
end

function Primwin:LoadDefaults()
	Loadtime = Turbine.Engine.GetGameTime()
	Fadetime = Loadtime + 4
	CritLevelT = .2
	LowLevelT = .5
	PLowLevelT = .4
	PCritLevelT = .2
	LowScroll:SetValue ( 50 )
	PLowScroll:SetValue( 40 )
	CriticalScroll:SetMaximum( 50 )
	CriticalScroll:SetValue( 20 )
	PCriticalScroll:SetMaximum( 40 )
	PCriticalScroll:SetValue( 20 )
	LowScrollLabel:SetText( "50% - Low Morale Level" )
	PLowScrollLabel:SetText( "40% - Low Power Level" )
	CriticalScrollLabel:SetText( "20% - Critical Morale Level" )
	PCriticalScrollLabel:SetText( "20% - Critical Power Level" )
	DHitLevel = 3000
	DHitScroll:SetValue( 3000 )
	DHitScrollLabel:SetText( "3000 - Devastating Hit Size" )
	AWarnFading = "False"

	quickslots = "Enabled"
	QScheck:SetChecked( true )
	Barcheck:SetChecked( true )
	Bars = "Enabled" 
	Moralewarn = "Enabled"
	MWarncheck:SetChecked( true )
	Powerwarn = "Enabled"
	PWarncheck:SetChecked( true )
	DHitWarncheck:SetChecked( true )
	InterruptCDcheck:SetChecked( true )
	PanCDcheck:SetChecked( true )
	BubCDcheck:SetChecked( true )
	Textcheck:SetChecked( true )
	CorruptionCDcheck:SetChecked( true )
	C1check:SetChecked( false )
	C2check:SetChecked( false )
	IndOnlycheck:SetChecked( false )
	IndOnly = "Disabled" 
	DHitWarning = "Enabled"
	InterruptCD = "Enabled"
	CorruptionCD = "Enabled"
	PanCD = "Enabled"
	BubCD = "Enabled"
	Text = "Enabled"
	Cus1CD = "Disabled"
	Cus2CD = "Disabled"
	Meter = "Enabled"
	MeterCheck:SetChecked(true)
	MeterCheck:SetEnabled( true )

	MQSO:SetShortcut( Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Undefined, MShortcut ) )
	PQSO:SetShortcut( Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Undefined, PShortcut ) )
	FQSO:SetShortcut( Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Undefined, FShortcut ) )
	DQSO:SetShortcut( Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Undefined, DShortcut ) )
	WQSO:SetShortcut( Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Undefined, WShortcut ) )
	PoQSO:SetShortcut( Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Undefined, PoShortcut ) )
	MQS:SetShortcut( Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Undefined, MShortcut ) )
	PQS:SetShortcut( Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Undefined, PMShortcut ) )
	FQS:SetShortcut( Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Undefined, FShortcut ) )
	DQS:SetShortcut( Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Undefined, DShortcut ) )
	WQS:SetShortcut( Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Undefined, WShortcut ) )
	PoQS:SetShortcut( Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Undefined, PoShortcut ) )

	MShortcut = MQSO:GetShortcut()
	PShortcut = PQSO:GetShortcut()
	FShortcut = FQSO:GetShortcut()
	DShortcut = DQSO:GetShortcut()
	WShortcut = WQSO:GetShortcut()
	PoShortcut = PoQSO:GetShortcut()

	BOSLabel:SetText( "30% Bar Opacity" )
	BopF = ( 30 )
	BopT = ( .3 )
	BOS:SetValue( 30 )

	MOSLabel:SetText( "30% Meter Opacity" )
	MopF = ( 30 )
	MopT = ( .3 )
	MOS:SetValue( 30 )

	MWOSLabel:SetText( "100% Morale Warning Opacity" )
	MWopF = ( 100 )
	MWopT = ( 1 )
	MWOS:SetValue( 100 )
	MWarn:SetOpacity( 1 )

	PWOSLabel:SetText( "100% Power Warning Opacity" )
	PWopF = ( 100 )
	PWopT = ( 1 )
	PWOS:SetValue( 100 )
	PWarn:SetOpacity( 1 )

	DHOSLabel:SetText( "100% Dev. Hit Warning Opac." )
	DHopF = ( 100 )
	DHopT = ( 1 )
	DHOS:SetValue( 100 )
	DHitWarn:SetOpacity( 1 )

	PSL:SetText( "0" )
	PanScroll:SetValue( 0 )
	
	BSL:SetText( "0" )
	BubScroll:SetValue( 0 )

	ISL:SetText( "0" )
	IntScroll:SetValue( 0 )

	CSL:SetText( "0" )
	CorScroll:SetValue( 0 )

	C1SL:SetText( "0" )
	C1Scroll:SetValue( 0 )

	C2SL:SetText( "0" )
	C2Scroll:SetValue( 0 )

	PanRdytime = 0
	CorrRdytime = 0
	BubRdytime = 0
	IntRdytime = 0
	C1Rdytime = 0
	C2Rdytime = 0
	Pantext:SetText( "N/A" )
	Cortext:SetText( "N/A" )
	Bubtext:SetText( "N/A" )
	Inttext:SetText( "N/A" )
	C1text:SetText( "N/A" )
	C2text:SetText( "N/A" )
	PanCDing = "false"
	BubCDing = "false"
	CorrCDing = "false"
	IntCDing = "false"
	Cus1CDing = "false"
	Cus2CDing = "false"

	OOCcrit = "Out of Combat"
	OOClabel1:SetText( OOCcrit )

	Managercheck:SetChecked( false )
	loadwithman = "Disabled"
end

Primwin:LoadDefaults()

function HUDPlus:LoadData()
	PlayerClass = Player:GetClass()
	if PlayerClass == Turbine.Gameplay.Class.Champion
	then ChmpAtts = Player:GetClassAttributes()
	CurFervour = ChmpAtts:GetFervor()
	MeterCheck:SetEnabled( true )
	MeterRail:SetBackground( "CajePlugins/HUDPlus/Resources/MeterRailCHMP.tga" )
	MeterBar:SetBackground( "CajePlugins/HUDPlus/Resources/MeterColorCHMP.tga" )
	elseif PlayerClass == Turbine.Gameplay.Class.Hunter
	then HntAtts = Player:GetClassAttributes()
	CurFocus = HntAtts:GetFocus()
	MeterCheck:SetEnabled( true )
	MeterRail:SetBackground( "CajePlugins/HUDPlus/Resources/MeterRailHNT.tga" )
	MeterBar:SetBackground( "CajePlugins/HUDPlus/Resources/MeterColorCHMP.tga" )
	elseif PlayerClass == Turbine.Gameplay.Class.RuneKeeper
	then RKAtts = Player:GetClassAttributes()
	CurAtt = RKAtts:GetAttunement()
	MeterCheck:SetEnabled( true )
	MeterRail:SetBackground( "CajePlugins/HUDPlus/Resources/MeterRailHNT.tga" )
	MeterBar:SetBackground( "CajePlugins/HUDPlus/Resources/MeterColorCHMP.tga" )
	else
	Meter = "Disabled"
	MeterCheck:SetEnabled( false )
	MeterCheck:SetChecked( false )
	end
	if loadwithman == "Disabled" or LOADED == "False" then
	PanCDing = "false"
	BubCDing = "false"
	CorrCDing = "false"
	IntCDing = "false"
	Cus1CDing = "false"
	Cus2CDing = "false"
	PanRdytime = 0
	CorrRdytime = 0
	BubRdytime = 0
	IntRdytime = 0
	C1Rdytime = 0
	C2Rdytime = 0
		Turbine.PluginData.Load( Turbine.DataScope.Character, "HUDPlus", 
		function ( HUDPlusData )
			if HUDPlusData ~= nil then

			CritLevelT = HUDPlusData.CritLevel
			LowLevelT = HUDPlusData.LowLevel
			PCritLevelT = HUDPlusData.PCritLevel
			PLowLevelT = HUDPlusData.PLowLevel
			DHitLevel = HUDPlusData.DLevel

			LowScroll:SetValue ( LowLevelT * 100 )
			PLowScroll:SetValue( PLowLevelT * 100 )
			CriticalScroll:SetMaximum( LowLevelT * 100 )
			PCriticalScroll:SetMaximum( PLowLevelT * 100 )
			CriticalScroll:SetValue( CritLevelT * 100 )
			PCriticalScroll:SetValue( PCritLevelT * 100 )
			LowScrollLabel:SetText( ( LowLevelT * 100 ).."% - Low Morale Level" )
			PLowScrollLabel:SetText( ( PLowLevelT * 100 ).."% - Low Power Level" )
			CriticalScrollLabel:SetText( ( CritLevelT * 100).."% - Critical Morale Level" )
			PCriticalScrollLabel:SetText( ( PCritLevelT * 100).."% - Critical Power Level" )
			DHitScroll:SetValue( DHitLevel )
			DHitScrollLabel:SetText( DHitLevel.." - Devastating Hit Size" )
			AWarnFading = "False"

			quickslots = HUDPlusData.quickslots
			Bars = HUDPlusData.Bars
			Meter = HUDPlusData.Meter
			Moralewarn = HUDPlusData.Moralewarn
			Powerwarn = HUDPlusData.Powerwarn
			PanCD = HUDPlusData.PancD
			BubCD = HUDPlusData.BubCD
			Text = HUDPlusData.Text
			CorruptionCD = HUDPlusData.CorruptionCD
			InterruptCD = HUDPlusData.InterruptCD
			DHitWarning = HUDPlusData.DHitWarning
			Cus1CD = HUDPlusData.Cus1CD
			Cus2CD = HUDPlusData.Cus1CD
			IndOnly = HUDPlusData.IndOnly

			if quickslots == "Enabled" then
			QScheck:SetChecked( true )
			else QSCheck:SetChecked( false )
			end
			if Bars == "Enabled" then
			Barcheck:SetChecked( true )
			else Barcheck:SetChecked( false )
			end
			if Meter == "Enabled" then
			MeterCheck:SetChecked( true )
			else MeterCheck:SetChecked( false )
			Meter = "Disabled"
			end
			if Moralewarn == "Enabled" then
			MWarncheck:SetChecked( true )
			else MWarncheck:SetChecked( false )
			end
			if Powerwarn == "Enabled" then
			PWarncheck:SetChecked( true ) 
			else PWarncheck:SetChecked( false )
			end
			if DHitWarning == "Enabled" then
			DHitWarncheck:SetChecked( true )
			else DHitWarncheck:SetChecked( false )
			end
			if InterruptCD == "Enabled" then
			InterruptCDcheck:SetChecked( true )
			else InterruptCDcheck:SetChecked( false )
			end
			if PanCD == "Enabled" then
			PanCDcheck:SetChecked( true )
			else PanCDcheck:SetChecked( false )
			end
			if BubCD == "Enabled" then
			BubCDcheck:SetChecked( true )
			else BubCDcheck:SetChecked( false )
			end
			if Text == "Enabled" then
			Textcheck:SetChecked( true )
			else Textcheck:SetChecked( false )
			end
			if CorruptionCD == "Enabled" then
			CorruptionCDcheck:SetChecked( true )
			else CorruptionCDcheck:SetChecked( false )
			end
			if Cus1CD == "Enabled" then
			C1check:SetChecked( true )
			else C1check:SetChecked( false )
			end
			if Cus2CD == "Enabled" then
			C2check:SetChecked( true )
			else C2check:SetChecked( false )
			end
			if IndOnly == "Enabled" then
			IndOnlycheck:SetChecked( true )
			else IndOnlycheck:SetChecked( false )
			end

			MWopT = HUDPlusData.MWopT
			PWopT = HUDPlusData.PWopT
			DHopT = HUDPlusData.DHopT
			BopT = HUDPlusData.BopT
			MopT = HUDPlusData.MopT

			BOSLabel:SetText( (BopT * 100).."% Bar Opacity" )
			BopF = ( BopT * 100 )
			BOS:SetValue( BopF )

			MOSLabel:SetText( (MopT * 100).."% Meter Opacity" )
			MopF = ( MopT * 100 )
			MOS:SetValue( MopF )

			MWOSLabel:SetText( ( MWopT * 100 ).."% Morale Warning Opacity" )
			MWopF = ( MWopT * 100 )
			MWOS:SetValue( MWopF )
			MWarn:SetOpacity( MWopF )

			PWOSLabel:SetText( (PWopT * 100).."% Power Warning Opacity" )
			PWopF = ( PWopT * 100 )
			PWOS:SetValue( PWopF )
			PWarn:SetOpacity( PWopF )

			DHOSLabel:SetText( (DHopT * 100).."% Hit Warning Opac." )
			DHopF = ( DHopT * 100 )
			DHOS:SetValue( DHopF )
			DHitWarn:SetOpacity( DHopF )

			MQSO:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.MType, HUDPlusData.MData ) )
			PQSO:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.PType, HUDPlusData.PData ) )
			FQSO:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.FType, HUDPlusData.FData ) )
			DQSO:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.DType, HUDPlusData.DData ) )
			WQSO:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.WType, HUDPlusData.WData ) )
			PoQSO:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.PoType, HUDPlusData.PoData ) )
			MQS:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.MType, HUDPlusData.MData ) )
			PQS:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.PType, HUDPlusData.PData ) )
			FQS:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.FType, HUDPlusData.FData ) )
			DQS:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.DType, HUDPlusData.DData ) )
			WQS:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.WType, HUDPlusData.WData ) )
			PoQS:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.PoType, HUDPlusData.PoData ) )

			Pantext:SetText( HUDPlusData.Panskill )
			Cortext:SetText( HUDPlusData.Corskill )
			Inttext:SetText( HUDPlusData.Intskill )
			Bubtext:SetText( HUDPlusData.Bubskill )
			C1text:SetText( HUDPlusData.C1skill )
			C2text:SetText( HUDPlusData.C2skill )

			PanScroll:SetValue( HUDPlusData.PanicCD )
			CorScroll:SetValue( HUDPlusData.CorCD )
			IntScroll:SetValue( HUDPlusData.IntCD )
			BubScroll:SetValue( HUDPlusData.BubbCD )
			C1Scroll:SetValue( HUDPlusData.C1CD )
			C2Scroll:SetValue( HUDPlusData.C2CD )
			PSL:SetText( HUDPlusData.PanicCD )
			BSL:SetText( HUDPlusData.BubbCD )
			ISL:SetText( HUDPlusData.IntCD )
			CSL:SetText( HUDPlusData.CorCD )
			C1SL:SetText( HUDPlusData.C1CD )
			C2SL:SetText( HUDPlusData.C2CD )

			OOCcrit = HUDPlusData.OOCcrit
			OOClabel1:SetText( OOCcrit )

			Cus1CD = HUDPlusData.Cus1CD
			Cus2CD = HUDPlusData.Cus2CD
			if Cus1CD == "Enabled" then
			C1check:SetChecked( true )
			else C1check:SetChecked( false )
			end
			if Cus2CD == "Enabled" then
			C2check:SetChecked( true )
			else C2check:SetChecked( false )
			end

			MData = HUDPlusData.MData
			PData = HUDPlusData.PData
			DData = HUDPlusData.DData
			WData = HUDPlusData.WData
			FData = HUDPlusData.FData
			PoData = HUDPlusData.PoData
			MType = HUDPlusData.MType
			PType = HUDPlusData.PType
			DType = HUDPlusData.DType
			WType = HUDPlusData.WType
			FType = HUDPlusData.FType
			PoType = HUDPlusData.PoType
			
			loadwithman = HUDPlusData.loadwithman

				if loadwithman == "Enabled" then
				Managercheck:SetChecked( true )
				else Managercheck:SetChecked( false )
				end
			if loadwithman == "Disabled" then
				MQSO:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.MType, HUDPlusData.MData ) )
				PQSO:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.PType, HUDPlusData.PData ) )
				FQSO:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.FType, HUDPlusData.FData ) )
				DQSO:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.DType, HUDPlusData.DData ) )
				WQSO:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.WType, HUDPlusData.WData ) )
				PoQSO:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.PoType, HUDPlusData.PoData ) )
				MQS:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.MType, HUDPlusData.MData ) )
				PQS:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.PType, HUDPlusData.PData ) )
				FQS:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.FType, HUDPlusData.FData ) )
				DQS:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.DType, HUDPlusData.DData ) )
				WQS:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.WType, HUDPlusData.WData ) )
				PoQS:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.PoType, HUDPlusData.PoData ) )
			end

			MWarn:SetLeft( HUDPlusData.MWarnX )
			MWarn:SetTop( HUDPlusData.MWarnY )
			PWarn:SetLeft( HUDPlusData.PWarnX )
			PWarn:SetTop( HUDPlusData.PWarnY )
			DHitWarn:SetLeft( HUDPlusData.DHitWarnX )
			DHitWarn:SetTop( HUDPlusData.DHitWarnY )
			PanicCD:SetLeft( HUDPlusData.PanicCDX )
			PanicCD:SetTop( HUDPlusData.PanicCDY )
			BubbleCD:SetLeft( HUDPlusData.BubbleCDX )
			BubbleCD:SetTop( HUDPlusData.BubbleCDY )
			IntCD:SetLeft( HUDPlusData.IntCDX )
			IntCD:SetTop( HUDPlusData.IntCDY )
			CorrCD:SetLeft( HUDPlusData.CorrCDX )
			CorrCD:SetTop( HUDPlusData.CorrCDY )
			C1CD:SetLeft( HUDPlusData.C1CDX )
			C1CD:SetTop( HUDPlusData.C1CDY )
			C2CD:SetLeft( HUDPlusData.C2CDX )
			C2CD:SetTop( HUDPlusData.C2CDY )

			MQSG:SetLeft( HUDPlusData.MQSGX )
			MQSG:SetTop( HUDPlusData.MQSGY )
			PQSG:SetLeft( HUDPlusData.PQSGX )
			PQSG:SetTop( HUDPlusData.PQSGY )
			FQSG:SetLeft( HUDPlusData.FQSGX )
			FQSG:SetTop( HUDPlusData.FQSGY )
			DQSG:SetLeft( HUDPlusData.DQSGX )
			DQSG:SetTop( HUDPlusData.DQSGY )
			WQSG:SetLeft( HUDPlusData.WQSGX )
			WQSG:SetTop( HUDPlusData.WQSGY )
			PoQSG:SetLeft( HUDPlusData.PoQSGX )
			PoQSG:SetTop( HUDPlusData.PoQSGY )

			MBarWin:SetLeft( HUDPlusData.MBarX )
			MBarRail:SetLeft( HUDPlusData.MBarX )
			MBarWin:SetTop( HUDPlusData.MBarY )
			MBarRail:SetTop( HUDPlusData.MBarY )
			PBarWin:SetLeft( HUDPlusData.PBarX )
			PBarRail:SetLeft( HUDPlusData.PBarX )
			PBarWin:SetTop( HUDPlusData.PBarY )
			PBarRail:SetTop( HUDPlusData.PBarY )

			MTWin:SetTop( HUDPlusData.MTWinY )
			MTWin:SetLeft( HUDPlusData.MTWinX )
			PTWin:SetLeft( HUDPlusData.PTWinX )
			PTWin:SetTop( HUDPlusData.PTWinY )
			TTWin:SetLeft( HUDPlusData.TTWinX )
			TTWin:SetTop( HUDPlusData.TTWinY )

			MeterWin:SetLeft( HUDPlusData.MeterBarX )
			MeterRail:SetLeft( HUDPlusData.MeterBarX )
			MeterWin:SetTop( HUDPlusData.MeterBarY )
			MeterRail:SetTop( HUDPlusData.MeterBarY )

			else Primwin:LoadDefaults()
			end
		end
		);
	end
end

function Primwin:RecenterControls()
	MWarn:SetLeft( 180 + Primwin:GetLeft() );
	MWarn:SetTop( -40 + Primwin:GetTop() );
	PWarn:SetLeft( 180 + Primwin:GetLeft() );
	PWarn:SetTop( 100 + Primwin:GetTop() );
	DHitWarn:SetLeft( 110 + Primwin:GetLeft() )
	DHitWarn:SetTop( 150 + Primwin:GetTop() )
	PanicCD:SetLeft( 90 + Primwin:GetLeft() )
	PanicCD:SetTop( -40 + Primwin:GetTop() )
	BubbleCD:SetLeft( 280 + Primwin:GetLeft() )
	BubbleCD:SetTop( -40 + Primwin:GetTop() )
	CorrCD:SetLeft( 280 + Primwin:GetLeft() )
	CorrCD:SetTop( 105 + Primwin:GetTop() )
	IntCD:SetLeft( 90 + Primwin:GetLeft() )
	IntCD:SetTop( 105 + Primwin:GetTop() )
	C1CD:SetLeft( 20 + Primwin:GetLeft() )
	C1CD:SetTop( 105 + Primwin:GetTop() )
	C2CD:SetLeft( 360 + Primwin:GetLeft() )
	C2CD:SetTop( 105 + Primwin:GetTop() )
	WQSG:SetPosition( 140 + Primwin:GetLeft(), 70 + Primwin:GetTop() )
	DQSG:SetPosition( 180 + Primwin:GetLeft(), 70 + Primwin:GetTop() )
	MQSG:SetPosition( 100 + Primwin:GetLeft() , 70 + Primwin:GetTop() )
	PQSG:SetPosition( 305 + Primwin:GetLeft() , 70 + Primwin:GetTop() )
	PoQSG:SetPosition( 225 + Primwin:GetLeft(), 70 + Primwin:GetTop() )
	FQSG:SetPosition( 265 + Primwin:GetLeft() , 70 + Primwin:GetTop() )
	MBarRail:SetPosition( 20 + Primwin:GetLeft() , 10 + Primwin:GetTop() )
	PBarRail:SetPosition( 220 + Primwin:GetLeft(), 10 + Primwin:GetTop() )
	MBarWin:SetPosition( 20 + Primwin:GetLeft(), 10 + Primwin:GetTop() )
	PBarWin:SetPosition( 220 + Primwin:GetLeft(), 10 + Primwin:GetTop() )
	MeterWin:SetPosition( 90 + Primwin:GetLeft(), 195 + Primwin:GetTop() );
	MeterRail:SetPosition( 90 + Primwin:GetLeft() , 195 + Primwin:GetTop() );

	MTWin:SetPosition( 95 + Primwin:GetLeft(), 40 + Primwin:GetTop() )
	PTWin:SetPosition( 225 + Primwin:GetLeft(), 40 + Primwin:GetTop() )
	TTWin:SetPosition( 95 + Primwin:GetLeft(), 53 + Primwin:GetTop() )
end

HUDPlus:LoadData()

--HUD Functions

function MBar:ScanMorale()
	MaxM = ( Player:GetMaxMorale() )
	CurM = ( Player:GetMorale() )
	MPerc = ( CurM / MaxM )
	BarPerc = ( ( CurM ) / ( MaxM + Player:GetMaxTemporaryMorale() ) )
	CurTemp = Player:GetTemporaryMorale()
	CurTempMax = Player:GetMaxTemporaryMorale()
	TempPerc2 = ( CurTemp / ( MaxM + Player:GetMaxTemporaryMorale() ) )
	TempPerc = ( CurTemp / CurTempMax )
	if MPerc <= CritLevelT then
	MStat = "Critical"
	elseif MPerc <= LowLevelT then
	MStat = "Low"
	elseif MPerc >= LowLevelT then 
	MStat = "Normal"
	end
	if MPerc == 1 then
	MFull = "true"
	else MFull = "false"
	end
	MBar:SetLeft( 200 - ( MBarWin:GetWidth() * ( BarPerc ) ) )
	MBarT:SetLeft( ( TempPerc2 * 200 ) - 200 )
end

function PBar:ScanPower()
	MaxP = Player:GetMaxPower()
	CurP = Player:GetPower()
	PPerc = ( CurP / MaxP )
	if PPerc <= PCritLevelT then
	PStat = "Critical"
	elseif PPerc <= PLowLevelT then
	PStat = "Low"
	elseif PPerc >= PLowLevelT then 
	PStat = "Normal"
	end
	if PPerc == 1 then
	PFull = "true"
	else PFull = "false"
	end
	PBar:SetLeft( ( PBarWin:GetWidth() * ( PPerc ) ) - 200)
end

function MRealLabel:ScanMorale()
	MRealLabel:SetText( CurM )
	MMaxLabel:SetText( MaxM )
	MPercLabel:SetText( ( MPerc * 100 ) )
	if MaxM <= 10 then
	MMaxLabel:SetWidth( 7 )
	elseif MaxM <= 100 then
	MMaxLabel:SetWidth( 15 )
	elseif MaxM <= 1000 then
	MMaxLabel:SetWidth( 20 )
	elseif MaxM >= 10000 then
	MMaxLabel:SetWidth( 35 )
	elseif MaxM >= 1000 then
	MMaxLabel:SetWidth( 28 )
	end

	if CurM <= 10 then
	MRealLabel:SetWidth( 7 )
	elseif CurM <= 100 then
	MRealLabel:SetWidth( 15 )
	elseif CurM <= 1000 then
	MRealLabel:SetWidth( 20 )
	elseif CurM >= 10000 then
	MRealLabel:SetWidth( 35 )
	elseif CurM >= 1000 then
	MRealLabel:SetWidth( 28 )
	end

	if MPerc < .1 then
	MPercLabel:SetWidth( 7 )
	MPercLabel2:SetLeft( 99 )
	elseif MPerc < 1 
	then MPercLabel2:SetLeft( 104 )
	MPercLabel:SetWidth( 15 )
	elseif MPerc == 1 then
	MPercLabel2:SetLeft( 107 )
	MPercLabel:SetWidth( 20 )
	end

	if CurTempMax >= 0 then
	TMRealLabel:SetText( CurTemp )
	TMMaxLabel:SetText( CurTempMax )
	TMPercLabel:SetText( ( TempPerc * 100 ) )
	end

	if CurTempMax <= 10 then
	TMMaxLabel:SetWidth( 7 )
	elseif CurTempMax <= 100 then
	TMMaxLabel:SetWidth( 15 )
	elseif CurTempMax <= 1000 then
	TMMaxLabel:SetWidth( 20 )
	elseif CurTempMax >= 10000 then
	TMMaxLabel:SetWidth( 35 )
	elseif CurTempMax >= 1000 then
	TMMaxLabel:SetWidth( 28 )
	end

	if CurTemp <= 10 then
	TMRealLabel:SetWidth( 7 )
	elseif CurTemp <= 100 then
	TMRealLabel:SetWidth( 15 )
	elseif CurTemp <= 1000 then
	TMRealLabel:SetWidth( 20 )
	elseif CurTemp >= 10000 then
	TMRealLabel:SetWidth( 35 )
	elseif CurTemp >= 1000 then
	TMRealLabel:SetWidth( 28 )
	end

	if TempPerc < .1 then
	TMPercLabel:SetWidth( 7 )
	TMPercLabel2:SetLeft( 99 )
	elseif TempPerc < 1 
	then TMPercLabel2:SetLeft( 104 )
	TMPercLabel:SetWidth( 15 )
	elseif TempPerc == 1 then
	TMPercLabel2:SetLeft( 107 )
	TMPercLabel:SetWidth( 20 )
	end

	if CurTempMax > 0 and Text == "Enabled" then
	TTWin:SetVisible( true )
	elseif CurTempMax == 0 or Text == "Disabled" then
	TTWin:SetVisible( false )
	end
end

function PRealLabel:ScanPower()
	PRealLabel:SetText( CurP )
	PMaxLabel:SetText( MaxP )
	PPercLabel:SetText( ( PPerc * 100 ) )
	if MaxP <= 10 then
	PMaxLabel:SetWidth( 5 )
	elseif MaxP <= 100 then
	PMaxLabel:SetWidth( 15 )
	elseif MaxP <= 1000 then
	PMaxLabel:SetWidth( 20 )
	elseif MaxP >= 10000 then
	PMaxLabel:SetWidth( 35 )
	elseif MaxP >= 1000 then
	PMaxLabel:SetWidth( 28 )
	end

	if CurP <= 10 then
	PRealLabel:SetWidth( 5 )
	elseif CurP <= 100 then
	PRealLabel:SetWidth( 15 )
	elseif CurP <= 1000 then
	PRealLabel:SetWidth( 20 )
	elseif CurP >= 10000 then
	PRealLabel:SetWidth( 35 )
	elseif CurP >= 1000 then
	PRealLabel:SetWidth( 28 )
	end

	if PPerc < .1 then
	PPercLabel:SetWidth( 7 )
	PPercLabel2:SetLeft( 14 )
	elseif PPerc < 1 
	then PPercLabel2:SetLeft( 19 )
	PPercLabel:SetWidth( 15 )
	elseif PPerc == 1 then
	PPercLabel2:SetLeft( 22 )
	PPercLabel:SetWidth( 20 )
	end
end

function MQSG:ScanMorale()
	if MStat == "Normal" then
	MQSG:SetVisible( false )
	MQS:SetVisible( false )	
	elseif MStat == "Low" or MStat == "Critical" then
	MQSG:SetVisible( true )
	MQS:SetVisible( true )
	end
	if MStat == "Normal" and MWarn:IsVisible() == true and MWarnFading ~= "True" then
	MWarn:FadeStart()
	MWarnFlashOut = "False"
	MWarnFlashIn = "False"
	elseif MStat == "Low" then
	MWarn:SetVisible( true )
	MWarnFlashOut = "False"
	MWarnFlashIn = "False"
	elseif MStat == "Critical" then
	MWarn:FlashOutStart()
	MWarn:SetVisible( true )
	end
end

function PQSG:ScanPower()
	if PStat == "Normal" then
	PQSG:SetVisible( false )
	PQS:SetVisible( false )
	elseif PStat == "Low" or PStat == "Critical" then
	PQSG:SetVisible( true )
	PQS:SetVisible( true )
	end
	if PStat == "Normal" and PWarn:IsVisible() == true and PWarnFading ~= "True" then
	PWarn:FadeStart()
	PWarnFlashOut = "False"
	PWarnFlashIn = "False"
	elseif PStat == "Low" then
	PWarn:SetVisible( true )
	PWarnFlashOut = "False"
	PWarnFlashIn = "False"
	elseif PStat == "Critical" then
	PWarn:FlashOutStart()
	PWarn:SetVisible( true )
	end
end

function Primwin:ScanEffects()
	Wounds = 0
	Diseases = 0
	Fears = 0
	Poisons = 0
	EffectList = Player:GetEffects()
	for i = 1, EffectList:GetCount() do
	Effect = EffectList:Get( i )
	Category = Effect:GetCategory()
		if Category == ( Turbine.Gameplay.EffectCategory.Wound ) and Effect:IsCurable() == true then
		Wounds = Wounds + 1 
		elseif Category == ( Turbine.Gameplay.EffectCategory.Disease ) and Effect:IsCurable() == true then
		Diseases = Diseases + 1
		elseif Category == ( Turbine.Gameplay.EffectCategory.Poison ) and Effect:IsCurable() == true then
		Poisons = Poisons + 1
		elseif Category == ( Turbine.Gameplay.EffectCategory.Fear ) and Effect:IsCurable() == true then
		Fears = Fears + 1
		end
	end
	if Diseases > 0 then
	DQSG:SetVisible( true )
	DQS:SetVisible( true )
	elseif Diseases == 0 then
	DQSG:SetVisible( false )
	DQS:SetVisible( false )
	end
	if Poisons > 0 then
	PoQSG:SetVisible( true )
	PoQS:SetVisible( true )
	elseif Poisons == 0 then
	PoQSG:SetVisible( false )
	PoQS:SetVisible( false )
	end
	if Fears > 0 then
	FQSG:SetVisible( true )
	FQS:SetVisible( true )
	elseif Fears == 0 then
	FQSG:SetVisible( false )
	FQS:SetVisible( false )
	end
	if Wounds > 0 then
	WQSG:SetVisible( true )
	WQS:SetVisible( true )
	elseif Wounds == 0 then
	WQSG:SetVisible( false )
	WQS:SetVisible( false )
	end
end

function DHitWarn:ScanMorale()
	Morale = Player:GetMorale()
	MoraleDif = ( Morale - StartMorale )
	StartMorale = Player:GetMorale()
	if MoraleDif < ( DHitLevel * -1 ) then
		DHitWarn:SetVisible( true )
		DVistime = LocTime
		DDistime = DVistime + 3
	end
	if DVistime ~= 0 and DDistime == LocTime then
	DHitWarn:FadeStart()
	end

end

function DHitWarn:FadeStart()
	FrameTime = Turbine.Engine.GetGameTime()
	DP0 = FrameTime
	DP1 = FrameTime + .05
	DP2 = FrameTime + .1
	DP3 = FrameTime + .15
	DP4 = FrameTime + .2
	DP5 = FrameTime + .25
	DP6 = FrameTime + .3
	DP7 = FrameTime + .35
	DP8 = FrameTime + .4
	DP9 = FrameTime + .45
	DP10 = FrameTime + .5
	DHitWarnFading = "True"
	DHitWarn:SetOpacity( 1 * DHopT )
end

function DHitWarn:FadeOut()
	if FrameTime > DP0 and FrameTime < DP1 then
	DHitWarn:SetOpacity( .9 * DHopT )
	elseif FrameTime > DP1 and FrameTime < DP2 then
	DHitWarn:SetOpacity( .8 * DHopT )
	elseif FrameTime > DP2 and FrameTime < DP3 then
	DHitWarn:SetOpacity( .7 * DHopT )
	elseif FrameTime > DP3 and FrameTime < DP4 then
	DHitWarn:SetOpacity( .6 * DHopT )
	elseif FrameTime > DP4 and FrameTime < DP5 then
	DHitWarn:SetOpacity( .5 * DHopT )
	elseif FrameTime > DP5 and FrameTime < DP6 then
	DHitWarn:SetOpacity( .4 * DHopT )
	elseif FrameTime > DP6 and FrameTime < DP7 then
	DHitWarn:SetOpacity( .3 * DHopT )
	elseif FrameTime > DP7 and FrameTime < DP8 then
	DHitWarn:SetOpacity( .2 * DHopT )
	elseif FrameTime > DP8 and FrameTime < DP9 then
	DHitWarn:SetOpacity( .1 * DHopT )
	elseif FrameTime > DP9 and FrameTime < DP10 then
	DHitWarn:SetOpacity( 1 * DHopT )
	DHitWarn:SetVisible( false )
	DHitWarn:SetMouseVisible( false )
	DHitWarnFading = "False"
	elseif FrameTime > DP10 then 
	DHitWarn:SetOpacity( 1 * DHopT )
	DHitWarn:SetVisible( false )
	DHitWarn:SetMouseVisible( false )
	DHitWarnFading = "False"
	end
end

function MWarn:FadeStart()
	FrameTime = Turbine.Engine.GetGameTime()
	MP0 = FrameTime
	MP1 = FrameTime + .05
	MP2 = FrameTime + .1
	MP3 = FrameTime + .15
	MP4 = FrameTime + .2
	MP5 = FrameTime + .25
	MP6 = FrameTime + .3
	MP7 = FrameTime + .35
	MP8 = FrameTime + .4
	MP9 = FrameTime + .45
	MP10 = FrameTime + .5
	MWarnFading = "True"
	MWarn:SetOpacity( 1 * MWopT )
end

function MWarn:FlashOutStart()
	if MWarnFlashOut == "False" then
	FrameTime = Turbine.Engine.GetGameTime()
	FMP0 = FrameTime
	FMP1 = FrameTime + .05
	FMP2 = FrameTime + .1
	FMP3 = FrameTime + .15
	FMP4 = FrameTime + .2
	FMP5 = FrameTime + .25
	FMP6 = FrameTime + .3
	FMP7 = FrameTime + .35
	FMP8 = FrameTime + .4
	FMP9 = FrameTime + .45
	FMP10 = FrameTime + .5
	MWarnFlashOut = "True"
	MWarn:SetOpacity( MWopT )
	end
end

function MWarn:FlashInStart()
	if MWarnFlashIn == "False" then
	FrameTime = Turbine.Engine.GetGameTime()
	FMP0 = FrameTime
	FMP1 = FrameTime + .05
	FMP2 = FrameTime + .1
	FMP3 = FrameTime + .15
	FMP4 = FrameTime + .2
	FMP5 = FrameTime + .25
	FMP6 = FrameTime + .3
	FMP7 = FrameTime + .35
	FMP8 = FrameTime + .4
	FMP9 = FrameTime + .45
	FMP10 = FrameTime + .5
	MWarnFlashIn = "True"
	end
end

function MWarn:FadeOut()
	if MWarn:IsVisible() == true then
		if FrameTime >= MP0 and FrameTime < MP1 then
		MWarn:SetOpacity( .9  * MWopT )
		elseif FrameTime > MP1 and FrameTime < MP2 then
		MWarn:SetOpacity( .8 * MWopT )
		elseif FrameTime > MP2 and FrameTime < MP3 then
		MWarn:SetOpacity( .7 * MWopT )
		elseif FrameTime > MP3 and FrameTime < MP4 then
		MWarn:SetOpacity( .6 * MWopT )
		elseif FrameTime > MP4 and FrameTime < MP5 then
		MWarn:SetOpacity( .5 * MWopT )
		elseif FrameTime > MP5 and FrameTime < MP6 then
		MWarn:SetOpacity( .4 * MWopT )
		elseif FrameTime > MP6 and FrameTime < MP7 then
		MWarn:SetOpacity( .3 * MWopT )
		elseif FrameTime > MP7 and FrameTime < MP8 then
		MWarn:SetOpacity( .2 * MWopT )
		elseif FrameTime > MP8 and FrameTime < MP9 then
		MWarn:SetOpacity( .1 * MWopT )
		elseif FrameTime > MP9 and FrameTime < MP10 then
		MWarn:SetOpacity( 1 * MWopT )
		MWarn:SetVisible( false )
		MWarn:SetMouseVisible( false )
		MWarnFading = "False"
		elseif FrameTime > MP10 then
		MWarn:SetOpacity( 1 * MWopT )
		MWarn:SetVisible( false )
		MWarn:SetMouseVisible( false )
		MWarnFading = "False"
		end
	end
end

function MWarn:FlashOut()
		if FrameTime >= FMP0 and FrameTime < FMP1 then
		MWarn:SetOpacity( .9  * MWopT )
		elseif FrameTime > FMP1 and FrameTime < FMP2 then
		MWarn:SetOpacity( .8 * MWopT )
		elseif FrameTime > FMP2 and FrameTime < FMP3 then
		MWarn:SetOpacity( .7 * MWopT )
		elseif FrameTime > FMP3 and FrameTime < FMP4 then
		MWarn:SetOpacity( .6 * MWopT )
		elseif FrameTime > FMP4 and FrameTime < FMP5 then
		MWarn:SetOpacity( .5 * MWopT )
		elseif FrameTime > FMP5 and FrameTime < FMP6 then
		MWarn:SetOpacity( .4 * MWopT )
		elseif FrameTime > FMP6 and FrameTime < FMP7 then
		MWarn:SetOpacity( .3 * MWopT )
		elseif FrameTime > FMP7 and FrameTime < FMP8 then
		MWarn:SetOpacity( .2 * MWopT )
		elseif FrameTime > FMP8 and FrameTime < FMP9 then
		MWarn:SetOpacity( .1 * MWopT )
		elseif FrameTime > FMP9 and FrameTime < FMP10 then
		MWarnFlashOut = "False"
		MWarn:FlashInStart()
		MWarn:SetOpacity( 0 * MWopT )
		elseif FrameTime > FMP10 then
		MWarnFlashOut = "False"
		MWarn:FlashInStart()
		MWarn:SetOpacity( 0 * MWopT )
		end
end

function MWarn:FlashIn()
		if FrameTime >= FMP0 and FrameTime < FMP1 then
		MWarn:SetOpacity( .1  * MWopT )
		elseif FrameTime > FMP1 and FrameTime < FMP2 then
		MWarn:SetOpacity( .2 * MWopT )
		elseif FrameTime > FMP2 and FrameTime < FMP3 then
		MWarn:SetOpacity( .3 * MWopT )
		elseif FrameTime > FMP3 and FrameTime < FMP4 then
		MWarn:SetOpacity( .4 * MWopT )
		elseif FrameTime > FMP4 and FrameTime < FMP5 then
		MWarn:SetOpacity( .5 * MWopT )
		elseif FrameTime > FMP5 and FrameTime < FMP6 then
		MWarn:SetOpacity( .6 * MWopT )
		elseif FrameTime > FMP6 and FrameTime < FMP7 then
		MWarn:SetOpacity( .7 * MWopT )
		elseif FrameTime > FMP7 and FrameTime < FMP8 then
		MWarn:SetOpacity( .8 * MWopT )
		elseif FrameTime > FMP8 and FrameTime < FMP9 then
		MWarn:SetOpacity( .9 * MWopT )
		elseif FrameTime > FMP9 and FrameTime < FMP10 then
		MWarnFlashIn = "False"
		MWarn:FlashOutStart()
		MWarn:SetOpacity( 1 * MWopT )
		elseif FrameTime > FMP10 then
		MWarnFlashIn = "False"
		MWarn:FlashOutStart()
		MWarn:SetOpacity( 1 * MWopT )
		end
end

function PWarn:FadeStart()
	FrameTime = Turbine.Engine.GetGameTime()
	PP0 = FrameTime
	PP1 = FrameTime + .05
	PP2 = FrameTime + .1
	PP3 = FrameTime + .15
	PP4 = FrameTime + .2
	PP5 = FrameTime + .25
	PP6 = FrameTime + .3
	PP7 = FrameTime + .35
	PP8 = FrameTime + .4
	PP9 = FrameTime + .45
	PP10 = FrameTime + .5
	PWarnFading = "True"
	PWarn:SetOpacity( 1 * PWopT )
end

function PWarn:FlashOutStart()
	if PWarnFlashOut == "False" then
	FrameTime = Turbine.Engine.GetGameTime()
	FPP0 = FrameTime
	FPP1 = FrameTime + .05
	FPP2 = FrameTime + .1
	FPP3 = FrameTime + .15
	FPP4 = FrameTime + .2
	FPP5 = FrameTime + .25
	FPP6 = FrameTime + .3
	FPP7 = FrameTime + .35
	FPP8 = FrameTime + .4
	FPP9 = FrameTime + .45
	FPP10 = FrameTime + .5
	PWarnFlashOut = "True"
	PWarn:SetOpacity( PWopT )
	end
end

function PWarn:FlashInStart()
	if PWarnFlashIn == "False" then
	FrameTime = Turbine.Engine.GetGameTime()
	FPP0 = FrameTime
	FPP1 = FrameTime + .05
	FPP2 = FrameTime + .1
	FPP3 = FrameTime + .15
	FPP4 = FrameTime + .2
	FPP5 = FrameTime + .25
	FPP6 = FrameTime + .3
	FPP7 = FrameTime + .35
	FPP8 = FrameTime + .4
	FPP9 = FrameTime + .45
	FPP10 = FrameTime + .5
	PWarnFlashIn = "True"
	end
end

function PWarn:FadeOut()
	if PWarn:IsVisible() == true then
		if FrameTime >= PP0 and FrameTime < PP1 then
		PWarn:SetOpacity( .9 * PWopT )
		elseif FrameTime > PP1 and FrameTime < PP2 then
		PWarn:SetOpacity( .8 * PWopT )
		elseif FrameTime > PP2 and FrameTime < PP3 then
		PWarn:SetOpacity( .7 * PWopT )
		elseif FrameTime > PP3 and FrameTime < PP4 then
		PWarn:SetOpacity( .6 * PWopT )
		elseif FrameTime > PP4 and FrameTime < PP5 then
		PWarn:SetOpacity( .5 * PWopT )
		elseif FrameTime > PP5 and FrameTime < PP6 then
		PWarn:SetOpacity( .4 * PWopT )
		elseif FrameTime > PP6 and FrameTime < PP7 then
		PWarn:SetOpacity( .3 * PWopT )
		elseif FrameTime > PP7 and FrameTime < PP8 then
		PWarn:SetOpacity( .2 * PWopT )
		elseif FrameTime > PP8 and FrameTime < PP9 then
		PWarn:SetOpacity( .1 * PWopT )
		elseif FrameTime > PP9 and FrameTime < PP10 then
		PWarn:SetOpacity( 1 * PWopT )
		PWarn:SetVisible( false )
		PWarn:SetMouseVisible( false )
		PWarnFading = "False"
		elseif FrameTime > PP10 then
		PWarn:SetOpacity( 1 * PWopT )
		PWarn:SetVisible( false )
		PWarn:SetMouseVisible( false )
		PWarnFading = "False"
		end
	end
end

function PWarn:FlashOut()
		if FrameTime >= FPP0 and FrameTime < FPP1 then
		PWarn:SetOpacity( .9  * PWopT )
		elseif FrameTime > FPP1 and FrameTime < FPP2 then
		PWarn:SetOpacity( .8 * PWopT )
		elseif FrameTime > FPP2 and FrameTime < FPP3 then
		PWarn:SetOpacity( .7 * PWopT )
		elseif FrameTime > FPP3 and FrameTime < FPP4 then
		PWarn:SetOpacity( .6 * PWopT )
		elseif FrameTime > FPP4 and FrameTime < FPP5 then
		PWarn:SetOpacity( .5 * PWopT )
		elseif FrameTime > FPP5 and FrameTime < FPP6 then
		PWarn:SetOpacity( .4 * PWopT )
		elseif FrameTime > FPP6 and FrameTime < FPP7 then
		PWarn:SetOpacity( .3 * PWopT )
		elseif FrameTime > FPP7 and FrameTime < FPP8 then
		PWarn:SetOpacity( .2 * PWopT )
		elseif FrameTime > FPP8 and FrameTime < FPP9 then
		PWarn:SetOpacity( .1 * PWopT )
		elseif FrameTime > FPP9 and FrameTime < FPP10 then
		PWarnFlashOut = "False"
		PWarn:FlashInStart()
		PWarn:SetOpacity( 0 * PWopT )
		elseif FrameTime > FPP10 then
		PWarnFlashOut = "False"
		PWarn:FlashInStart()
		PWarn:SetOpacity( 0 * PWopT )
		end
end

function PWarn:FlashIn()
		if FrameTime >= FPP0 and FrameTime < FPP1 then
		PWarn:SetOpacity( .1  * PWopT )
		elseif FrameTime > FPP1 and FrameTime < FPP2 then
		PWarn:SetOpacity( .2 * PWopT )
		elseif FrameTime > FPP2 and FrameTime < FPP3 then
		PWarn:SetOpacity( .3 * PWopT )
		elseif FrameTime > FPP3 and FrameTime < FPP4 then
		PWarn:SetOpacity( .4 * PWopT )
		elseif FrameTime > FPP4 and FrameTime < FPP5 then
		PWarn:SetOpacity( .5 * PWopT )
		elseif FrameTime > FPP5 and FrameTime < FPP6 then
		PWarn:SetOpacity( .6 * PWopT )
		elseif FrameTime > FPP6 and FrameTime < FPP7 then
		PWarn:SetOpacity( .7 * PWopT )
		elseif FrameTime > FPP7 and FrameTime < FPP8 then
		PWarn:SetOpacity( .8 * PWopT )
		elseif FrameTime > FPP8 and FrameTime < FPP9 then
		PWarn:SetOpacity( .9 * PWopT )
		elseif FrameTime > FPP9 and FrameTime < FPP10 then
		PWarnFlashIn = "False"
		PWarn:FlashOutStart()
		PWarn:SetOpacity( 1 * PWopT )
		elseif FrameTime > FPP10 then
		PWarnFlashIn = "False"
		PWarn:FlashOutStart()
		PWarn:SetOpacity( 1 * PWopT )
		end
end

function Primwin:FadeStart()
	AP0 = FrameTime
	AP1 = FrameTime + .05
	AP2 = FrameTime + .1
	AP3 = FrameTime + .15
	AP4 = FrameTime + .2
	AP5 = FrameTime + .25
	AP6 = FrameTime + .3
	AP7 = FrameTime + .35
	AP8 = FrameTime + .4
	AP9 = FrameTime + .45
	AP10 = FrameTime + .5
	AWarnFading = "True"
	Primwin:SetOpacity( 1 )
end

function Primwin:FadeOut()
	if Primwin:IsVisible() == true then
		if FrameTime >= AP0 and FrameTime < AP1 then
		Primwin:SetOpacity( .9 )
		MTWin:SetOpacity( .9 )
		PTWin:SetOpacity( .9 )
		PanicCD:SetOpacity( .9 )
		BubbleCD:SetOpacity( .9 )
		CorrCD:SetOpacity( .9 )
		IntCD:SetOpacity( .9 )
		C1CD:SetOpacity( .9 )
		C2CD:SetOpacity( .9 )
		MBarWin:SetOpacity( .9  * BopT )
		MeterWin:SetOpacity( .9  * MopT )
		PBarWin:SetOpacity( .9  * BopT )
		elseif FrameTime > AP1 and FrameTime < AP2 then
		Primwin:SetOpacity( .8 )
		PTWin:SetOpacity( .8 )
		MTWin:SetOpacity( .8 )
		PanicCD:SetOpacity( .8 )
		BubbleCD:SetOpacity( .8 )
		CorrCD:SetOpacity( .8 )
		IntCD:SetOpacity( .8 )
		C1CD:SetOpacity( .8 )
		C2CD:SetOpacity( .8 )
		MBarWin:SetOpacity( .8  * BopT )
		MeterWin:SetOpacity( .8  * MopT )
		PBarWin:SetOpacity( .8  * BopT )
		elseif FrameTime > AP2 and FrameTime < AP3 then
		Primwin:SetOpacity( .7 )
		PTWin:SetOpacity( .7 )
		MTWin:SetOpacity( .7 )
		PanicCD:SetOpacity( .7 )
		BubbleCD:SetOpacity( .7 )
		CorrCD:SetOpacity( .7 )
		IntCD:SetOpacity( .7 )
		C1CD:SetOpacity( .7 )
		C2CD:SetOpacity( .7 )
		MBarWin:SetOpacity( .7  * BopT )
		MeterWin:SetOpacity( .7  * MopT )
		PBarWin:SetOpacity( .7  * BopT )
		elseif FrameTime > AP3 and FrameTime < AP4 then
		Primwin:SetOpacity( .6 )
		PTWin:SetOpacity( .6 )
		MTWin:SetOpacity( .6 )
		PanicCD:SetOpacity( .6 )
		BubbleCD:SetOpacity( .6 )
		CorrCD:SetOpacity( .6 )
		IntCD:SetOpacity( .6 )
		C1CD:SetOpacity( .6 )
		C2CD:SetOpacity( .6 )
		MBarWin:SetOpacity( .6  * BopT )
		MeterWin:SetOpacity( .6  * MopT )
		PBarWin:SetOpacity( .6  * BopT )
		elseif FrameTime > AP4 and FrameTime < AP5 then
		Primwin:SetOpacity( .5 )
		PTWin:SetOpacity( .5 )
		MTWin:SetOpacity( .5 )
		PanicCD:SetOpacity( .5 )
		BubbleCD:SetOpacity( .5 )
		CorrCD:SetOpacity( .5 )
		IntCD:SetOpacity( .5 )
		C1CD:SetOpacity( .5 )
		C2CD:SetOpacity( .5 )
		MBarWin:SetOpacity( .5  * BopT )
		MeterWin:SetOpacity( .5  * MopT )
		PBarWin:SetOpacity( .5  * BopT )
		elseif FrameTime > AP5 and FrameTime < AP6 then
		Primwin:SetOpacity( .4 )
		PTWin:SetOpacity( .4 )
		MTWin:SetOpacity( .4 )
		PanicCD:SetOpacity( .4 )
		BubbleCD:SetOpacity( .4 )
		CorrCD:SetOpacity( .4 )
		IntCD:SetOpacity( .4 )
		C1CD:SetOpacity( .4 )
		C2CD:SetOpacity( .4 )
		MBarWin:SetOpacity( .4  * BopT )
		MeterWin:SetOpacity( .4  * MopT )
		PBarWin:SetOpacity( .4  * BopT )
		elseif FrameTime > AP6 and FrameTime < AP7 then
		Primwin:SetOpacity( .3 )
		PTWin:SetOpacity( .3 )
		MTWin:SetOpacity( .3 )
		PanicCD:SetOpacity( .3 )
		BubbleCD:SetOpacity( .3 )
		CorrCD:SetOpacity( .3 )
		IntCD:SetOpacity( .3 )
		C1CD:SetOpacity( .3 )
		C2CD:SetOpacity( .3 )
		MBarWin:SetOpacity( .3  * BopT )
		MeterWin:SetOpacity( .3  * MopT )
		PBarWin:SetOpacity( .3  * BopT )
		elseif FrameTime > AP7 and FrameTime < AP8 then
		Primwin:SetOpacity( .2 )
		PTWin:SetOpacity( .2 )
		MTWin:SetOpacity( .2 )
		PanicCD:SetOpacity( .2 )
		BubbleCD:SetOpacity( .2 )
		CorrCD:SetOpacity( .2 )
		IntCD:SetOpacity( .2 )
		C1CD:SetOpacity( .2 )
		C2CD:SetOpacity( .2 )
		MBarWin:SetOpacity( .2  * BopT )
		MeterWin:SetOpacity( .2  * MopT )
		PBarWin:SetOpacity( .2  * BopT )
		elseif FrameTime > AP8 and FrameTime < AP9 then
		Primwin:SetOpacity( .1 )
		PTWin:SetOpacity( .1 )
		MTWin:SetOpacity( .1 )
		PanicCD:SetOpacity( .1 )
		BubbleCD:SetOpacity( .1 )
		CorrCD:SetOpacity( .1 )
		IntCD:SetOpacity( .1 )
		C1CD:SetOpacity( .1 )
		C2CD:SetOpacity( .1 )
		MBarWin:SetOpacity( .1  * BopT )
		MeterWin:SetOpacity( .1  * MopT )
		PBarWin:SetOpacity( .1  * BopT )
		elseif FrameTime > AP9 and FrameTime < AP10 then
		Primwin:SetOpacity( 1 )
		PTWin:SetOpacity( 1 )
		MTWin:SetOpacity( 1 )
		PanicCD:SetOpacity( 1 )
		BubbleCD:SetOpacity( 1 )
		CorrCD:SetOpacity( 1 )
		IntCD:SetOpacity( 1 )
		C1CD:SetOpacity( 1 )
		C2CD:SetOpacity( 1 )
		MBarWin:SetOpacity( 1  * BopT )
		PBarWin:SetOpacity( 1  * BopT )
		MeterWin:SetOpacity( 1  * MopT )
		Primwin:SetVisible( false )
		Primwin:SetVisible( false )
		PanicCD:SetVisible( false )
		BubbleCD:SetVisible( false )
		CorrCD:SetVisible( false )
		IntCD:SetVisible( false )
		C1CD:SetVisible( false )
		C2CD:SetVisible( false )
		MBarWin:SetMouseVisible( false )
		MBarWin:SetVisible( false )
		PBarWin:SetMouseVisible( false )
		PBarWin:SetVisible( false )
		MBarRail:SetVisible( false )
		PBarRail:SetVisible( false )
		MTWin:SetVisible( false )
		MTWin:SetMouseVisible( false )
		PTWin:SetVisible( false )
		PTWin:SetMouseVisible( false )
		MeterWin:SetMouseVisible( false )
		MeterWin:SetVisible( false )
		MeterRail:SetVisible( false )
		AWarnFading = "False"
		elseif FrameTime > AP10 then
		Primwin:SetOpacity( 1 )
		PTWin:SetOpacity( 1 )
		MTWin:SetOpacity( 1 )
		PanicCD:SetOpacity( 1 )
		BubbleCD:SetOpacity( 1 )
		CorrCD:SetOpacity( 1 )
		IntCD:SetOpacity( 1 )
		C1CD:SetOpacity( 1 )
		C2CD:SetOpacity( 1 )
		MBarWin:SetOpacity( 1  * BopT )
		MeterWin:SetOpacity( 1  * MopT )
		PBarWin:SetOpacity( 1  * BopT )
		Primwin:SetVisible( false )
		PanicCD:SetVisible( false )
		BubbleCD:SetVisible( false )
		CorrCD:SetVisible( false )
		IntCD:SetVisible( false )
		C1CD:SetVisible( false )
		C2CD:SetVisible( false )
		MBarWin:SetMouseVisible( false )
		MBarWin:SetVisible( false )
		MBarRail:SetVisible( false )
		MeterWin:SetMouseVisible( false )
		MeterWin:SetVisible( false )
		MeterRail:SetVisible( false )
		PBarWin:SetMouseVisible( false )
		PBarWin:SetVisible( false )
		PBarRail:SetVisible( false )
		MTWin:SetVisible( false )
		MTWin:SetMouseVisible( false )
		PTWin:SetVisible( false )
		PTWin:SetMouseVisible( false )
		AWarnFading = "False"
		end
	end
end

function Turbine.Chat:Received( args )
	msg = args.Message
	if msg ~= nil then
		msg = string.gsub( msg, "-", "_" )
		if args.ChatType == Turbine.ChatType.EnemyCombat or args.ChatType == Turbine.ChatType.PlayerCombat or args.ChatType == Turbine.ChatType.EventCombat and msg ~= nil then
			if string.find( msg, string.gsub( Pantext:GetText(), "-", "_" ) ) ~= nil and PanCDing == "false" then
			PanicCD:SetBackground( "CajePlugins/HUDPlus/Resources/PanicCDWait.tga" )
			PanicCD:TimerStart()
			end
			if string.find( msg, string.gsub( Cortext:GetText(), "-", "_" ) ) ~= nil and CorrCDing == "false" then
			CorrCD:SetBackground( "CajePlugins/HUDPlus/Resources/CorruptionCDWait.tga" )
			CorrCD:TimerStart()
			end
			if string.find( msg, string.gsub( Bubtext:GetText(), "-", "_" ) ) ~= nil and BubCDing == "false" then
			BubbleCD:SetBackground( "CajePlugins/HUDPlus/Resources/BubbleCDWait.tga" )
			BubbleCD:TimerStart()
			end
			if string.find( msg, string.gsub( Inttext:GetText(), "-", "_" ) ) ~= nil and IntCDing == "false" then
			IntCD:SetBackground( "CajePlugins/HUDPlus/Resources/InterruptCDWait.tga" )
			IntCD:TimerStart()
			end
			if string.find( msg, string.gsub( C1text:GetText(), "-", "_" ) ) ~= nil and Cus1CDing == "false" then
			C1CD:SetBackground( "CajePlugins/HUDPlus/Resources/CustomCDWait.tga" )
			C1CD:TimerStart()
			end
			if string.find( msg, string.gsub( C2text:GetText(), "-", "_" ) ) ~= nil and Cus2CDing == "false" then
			C2CD:SetBackground( "CajePlugins/HUDPlus/Resources/CustomCDWait.tga" )
			C2CD:TimerStart()
			end
		end
	end
end

function MQSO:DragDrop()
	MShortcut = MQSO:GetShortcut()
	MItem = MShortcut:GetItem()
	if MItem:GetQuantity() ~= 1 then
	MLastPot = "false"
	end
end
function PQSO:DragDrop()
	PShortcut = PQSO:GetShortcut()
	PItem = PShortcut:GetItem()
	if PItem:GetQuantity() ~= 1 then
	PLastPot = "false"
	end
end
function PoQSO:DragDrop()
	PoShortcut = PoQSO:GetShortcut()
	PoItem = PoShortcut:GetItem()
	if PoItem:GetQuantity() ~= 1 then
	PoLastPot = "false"
	end
end
function DQSO:DragDrop()
	DShortcut = DQSO:GetShortcut()
	DItem = DShortcut:GetItem()
	if DItem:GetQuantity() ~= 1 then
	DLastPot = "false"
	end
end
function WQSO:DragDrop()
	WShortcut = WQSO:GetShortcut()
	WItem = WShortcut:GetItem()
	if WItem:GetQuantity() ~= 1 then
	WLastPot = "false"
	end
end
function FQSO:DragDrop()
	FShortcut = FQSO:GetShortcut()
	FItem = FShortcut:GetItem()
	if FItem:GetQuantity() ~= 1 then
	FLastPot = "false"
	end
end

function Primwin:Update()
	if LOADED == "FALSE" and loadwithman == "Enabled" and QSLoadTime <= Turbine.Engine.GetLocalTime() then
		HUDPlus:LoadData()
		LOADED = "TRUE"
	end
	if HUDVis == "True" then
	Primwin:SetOpacity( 1 )
	PanicCD:SetOpacity( 1 )
	BubbleCD:SetOpacity( 1 )
	CorrCD:SetOpacity( 1 )
	IntCD:SetOpacity( 1 )
	C1CD:SetOpacity( 1 )
	C2CD:SetOpacity( 1 )
	MBarWin:SetOpacity( BopT )
	PBarWin:SetOpacity( BopT )
	MBarRail:SetOpacity( BopT )
	PBarRail:SetOpacity( BopT )
	MeterWin:SetOpacity( MopT )
	MeterRail:SetOpacity( MopT )
	MWarn:SetOpacity( MWopT )
	PWarn:SetOpacity( MWopT )
	DHitWarn:SetOpacity( DHopT )
	SwindowMaster:SetOpacity( 1 )
	PTWin:SetOpacity( 1 )
	MTWin:SetOpacity( 1 )
	TTWin:SetOpacity( 1 )
	MQS:SetVisible( true )
	PQS:SetVisible( true )
	WQS:SetVisible( true )
	PoQS:SetVisible( true )
	FQS:SetVisible( true )
	DQS:SetVisible( true )
	MQSG:SetVisible( true )
	PQSG:SetVisible( true )
	WQSG:SetVisible( true )
	PoQSG:SetVisible( true )
	FQSG:SetVisible( true )
	DQSG:SetVisible( true )
	end
	LocTime = Turbine.Engine.GetLocalTime()
	FrameTime = Turbine.Engine.GetGameTime()
	MBar:ScanMorale()
	PBar:ScanPower()
	if MFull == "true" and PFull == "true" then
	Vit100 = "true"
	else Vit100 = "false"
	end
	MQSG:ScanMorale()
	PQSG:ScanPower()
	MRealLabel:ScanMorale()
	PRealLabel:ScanPower()
	Primwin:ScanEffects()
	DHitWarn:ScanMorale()

	if DHitWarnFading == "True" then
	DHitWarn:FadeOut()
	end
	if MWarnFading == "True" then
	MWarn:FadeOut()
	end
	if PWarnFading == "True" then
	PWarn:FadeOut()
	end
	if AWarnFading == "True" then
	Primwin:FadeOut()
	end
	if MWarnFlashOut == "True" then
	MWarn:FlashOut()
	end
	if MWarnFlashIn == "True" then
	MWarn:FlashIn()
	end
	if PWarnFlashOut == "True" then
	PWarn:FlashOut()
	end
	if PWarnFlashIn == "True" then
	PWarn:FlashIn()
	end
	if IndOnly == "Enabled" then
	MQSG2:SetMouseVisible( true )
	MQL:SetVisible( false )
	PQSG2:SetMouseVisible( true )
	PQL:SetVisible( false )
	WQSG2:SetMouseVisible( true )
	WQL:SetVisible( false )
	DQSG2:SetMouseVisible( true )
	DQL:SetVisible( false )
	FQSG2:SetMouseVisible( true )
	FQL:SetVisible( false )
	PoQSG2:SetMouseVisible( true )
	PoQL:SetVisible( false )
	elseif IndOnly == "Disabled" then
	MQSG2:SetMouseVisible( false )
	MQL:SetVisible( true )
	PQSG2:SetMouseVisible( false )
	PQL:SetVisible( true )
	WQSG2:SetMouseVisible( false )
	WQL:SetVisible( true )
	DQSG2:SetMouseVisible( false )
	DQL:SetVisible( true )
	FQSG2:SetMouseVisible( false )
	FQL:SetVisible( true )
	PoQSG2:SetMouseVisible( false )
	PoQL:SetVisible( true )
	end
	if Optoverride == "True" then
		Primwin:SetVisible( true )
		if quickslots == "Enabled" then
		MQSG:SetVisible( true )
		MQSG:SetMouseVisible( true )
		MQS:SetVisible( false )
		PQSG:SetVisible( true )
		PQSG:SetMouseVisible( true )
		PQS:SetVisible( false )
		DQSG:SetVisible( true )
		DQSG:SetMouseVisible( true )
		DQS:SetVisible( false )
		WQSG:SetVisible( true )
		WQSG:SetMouseVisible( true )
		WQS:SetVisible( false )
		PoQSG:SetVisible( true )
		PoQSG:SetMouseVisible( true )
		PoQS:SetVisible( false )
		FQSG:SetVisible( true )
		FQSG:SetMouseVisible( true )
		FQS:SetVisible( false )
		end
		if Bars == "Enabled" then
		MBar:SetVisible( true )
		MBarWin:SetVisible( true )
		MBarWin:SetMouseVisible( true )
		PBarWin:SetVisible( true )
		PBarWin:SetMouseVisible( true )
		PBar:SetVisible( true )
		MBarRail:SetVisible( true )
		PBarRail:SetVisible( true )
		end
		if Meter == "Enabled" then
		MeterBar:SetVisible( true )
		MeterWin:SetVisible( true )
		MeterRail:SetVisible( true )
		MeterWin:SetMouseVisible( true )
		end
		if Moralewarn == "Enabled" then
		MWarn:SetVisible( true )
		MWarn:SetOpacity( MWopT )
		MWarn:SetMouseVisible( true )
		end
		if Powerwarn == "Enabled" then
		PWarn:SetVisible( true )
		PWarn:SetOpacity( PWopT )
		PWarn:SetMouseVisible( true )
		end
		if DHitWarning == "Enabled" then
		DHitWarn:SetVisible( true )
		DHitWarn:SetOpacity( DHopT )
		DHitWarn:SetMouseVisible( true )
		end
		if InterruptCD == "Enabled" then
		IntCD:SetVisible( true )
		IntCD:SetMouseVisible( true )
		end
		if CorruptionCD == "Enabled" then
		CorrCD:SetVisible( true )
		CorrCD:SetMouseVisible( true )
		end
		if PanCD == "Enabled" then
		PanicCD:SetVisible( true )
		PanicCD:SetMouseVisible( true )
		end
		if BubCD == "Enabled" then
		BubbleCD:SetVisible( true )
		BubbleCD:SetMouseVisible( true )
		end
		if Cus1CD == "Enabled" then
		C1CD:SetVisible( true )
		C1CD:SetMouseVisible( true )
		end
		if Cus2CD == "Enabled" then
		C2CD:SetVisible( true )
		C2CD:SetMouseVisible( true )
		end
		if Text == "Enabled" then
		MTWin:SetVisible( true )
		MTWin:SetMouseVisible( true )
		PTWin:SetVisible( true )
		PTWin:SetMouseVisible( true )
		TTWin:SetVisible( true )
		TTWin:SetMouseVisible( true )
		end
	end

	MShortcut = MQSO:GetShortcut()
	MSType = MShortcut:GetType()
	MSData = MShortcut:GetData()
	MSItem = MShortcut:GetItem()

	PShortcut = PQSO:GetShortcut()
	PSType = PShortcut:GetType()
	PSData = PShortcut:GetData()
	PSItem = PShortcut:GetItem()

	DShortcut = DQSO:GetShortcut()
	DSType = DShortcut:GetType()
	DSData = DShortcut:GetData()
	DSItem = DShortcut:GetItem()

	FShortcut = FQSO:GetShortcut()
	FSType = FShortcut:GetType()
	FSData = FShortcut:GetData()
	FSItem = FShortcut:GetItem()

	WShortcut = WQSO:GetShortcut()
	WSType = WShortcut:GetType()
	WSData = WShortcut:GetData()
	WSItem = WShortcut:GetItem()

	PoShortcut = PoQSO:GetShortcut()
	PoSType = PoShortcut:GetType()
	PoSData = PoShortcut:GetData()
	PoSItem = PoShortcut:GetItem()
	
	if WSType == Turbine.UI.Lotro.ShortcutType.Item then
		if LOADED == "TRUE" or loadwithman == "Disabled" then
			WShortcut = WQSO:GetShortcut()
			WSType = WShortcut:GetType()
			WSData = WShortcut:GetData()
			if WSQty == 1 then
				WLastPot = "true"
			end
			if WSData ~= "" and WLastPot ~= "true" then
				WSItem = WShortcut:GetItem()
				WSQty = WSItem:GetQuantity()
				WQL:SetText( WSQty )
			end
		end
	end
	if DSType == Turbine.UI.Lotro.ShortcutType.Item then
		if LOADED == "TRUE" or loadwithman == "Disabled" then
		DShortcut = DQSO:GetShortcut()
		DSType = DShortcut:GetType()
		DSData = DShortcut:GetData()
			if DSQty == 1 then
				DLastPot = "true"
			end
		if DSData ~= "" and DLastPot ~= "true" then
		DSItem = DShortcut:GetItem()
		DSQty = DSItem:GetQuantity()
		DQL:SetText( DSQty )
		end
		end
	end
	if FSType == Turbine.UI.Lotro.ShortcutType.Item then
		if LOADED == "TRUE" or loadwithman == "Disabled" then
		FShortcut = FQSO:GetShortcut()
		FSType = FShortcut:GetType()
		FSData = FShortcut:GetData()
			if FSQty == 1 then
				FLastPot = "true"
			end
		if FSData ~= "" and FLastPot ~= "true" then
		FSItem = FShortcut:GetItem()
		FSQty = FSItem:GetQuantity()
		FQL:SetText( FSQty )
		end
		end
	end
	if PoSType == Turbine.UI.Lotro.ShortcutType.Item then
		if LOADED == "TRUE" or loadwithman == "Disabled" then
		PoShortcut = PoQSO:GetShortcut()
		PoSType = PoShortcut:GetType()
		PoSData = PoShortcut:GetData()
			if PoSQty == 1 then
				PoLastPot = "true"
			end
		if PoSData ~= "" and PoLastPot ~= "true" then
		PoSItem = PoShortcut:GetItem()
		PoSQty = PoSItem:GetQuantity()
		PoQL:SetText( PoSQty )
		end
		end
	end
	if PSType == Turbine.UI.Lotro.ShortcutType.Item then
		if LOADED == "TRUE" or loadwithman == "Disabled" then
			PShortcut = PQSO:GetShortcut()
			PSType = PShortcut:GetType()
			PSData = PShortcut:GetData()
			if PSQty == 1 then
				PLastPot = "true"
			end
			if PSData ~= "" and PLastPot ~= "true" then
				PSItem = PShortcut:GetItem()
				PSQty = PSItem:GetQuantity()
				PQL:SetText( PSQty )
			end
		end
	end
	if MSType == Turbine.UI.Lotro.ShortcutType.Item then
		if LOADED == "TRUE" or loadwithman == "Disabled" then
			MShortcut = MQSO:GetShortcut()
			MSType = MShortcut:GetType()
			MSData = MShortcut:GetData()
			if MSQty == 1 then
				MLastPot = "true"
			end
			if MSData ~= "" and MLastPot ~= "true" then
				MSItem = MShortcut:GetItem()
				MSQty = MSItem:GetQuantity()
				MQL:SetText( MSQty )
			end
		end
	end

	if FrameTime >= PanRdytime and PanCDing == "true" then
		PanicCD:SetBackground( "CajePlugins/HUDPlus/Resources/PanicCDRdy.tga" )
		PanRdytime = 0
		PanCDing = "false" 
	end
	if FrameTime >= BubRdytime and BubCDing == "true" then
		BubbleCD:SetBackground( "CajePlugins/HUDPlus/Resources/BubbleCDRdy.tga" )
		BubRdytime = 0
		BubCDing = "false" 
	end
	if FrameTime >= CorrRdytime and CorrCDing == "true" then
		CorrCD:SetBackground( "CajePlugins/HUDPlus/Resources/CorruptionCDRdy.tga" )
		CorrRdytime = 0
		CorrCDing = "false" 
	end
	if FrameTime >= IntRdytime and IntCDing == "true" then
		IntCD:SetBackground( "CajePlugins/HUDPlus/Resources/InterruptCDRdy.tga" )
		IntRdytime = 0
		IntCDing = "false" 
	end
	if FrameTime >= C1Rdytime and Cus1CDing == "true" then
		C1CD:SetBackground( "CajePlugins/HUDPlus/Resources/CustomCDRdy.tga" )
		C1Rdytime = 0
		Cus1CDing = "false" 
	end
	if FrameTime >= C2Rdytime and Cus2CDing == "true" then
		C2CD:SetBackground( "CajePlugins/HUDPlus/Resources/CustomCDRdy.tga" )
		C2Rdytime = 0
		Cus2CDing = "false" 
	end

	if OOCcrit == "Out of Combat" then
		if Player:IsInCombat() == true then
		Primwin:SetVisible( true )
		if Bars == "Enabled" then
		MBarWin:SetVisible( true )
		MBarRail:SetVisible( true )
		PBarWin:SetVisible( true )
		PBarRail:SetVisible( true )
		end
		if Meter == "Enabled" then
		MeterWin:SetVisible( true )
		MeterRail:SetVisible( true )
		end
		if Text == "Enabled" then
		MTWin:SetVisible( true )
		PTWin:SetVisible( true )
		end
		if InterruptCD == "Enabled" then
			IntCD:SetVisible( true )
			IntCD:SetOpacity( 1 )
		end
		if CorruptionCD == "Enabled" then
			CorrCD:SetVisible( true )
			CorrCD:SetOpacity( 1 )
		end
		if PanCD == "Enabled" then
			PanicCD:SetVisible( true )
			PanicCD:SetOpacity( 1 )
		end
		if BubCD == "Enabled" then
			BubbleCD:SetVisible( true )
			BubbleCD:SetOpacity( 1 )
		end
		if Cus1CD == "Enabled" then
			C1CD:SetVisible( true )
			C1CD:SetOpacity( 1 )
		end
		if Cus2CD == "Enabled" then
			C2CD:SetVisible( true )
			C2CD:SetOpacity( 1 )
		end
		elseif Player:IsInCombat() == false and Primwin:IsVisible() == true and AWarnFading == "False"   and Primwin:IsVisible() == true and AWarnFading == "False" and SwindowMaster:IsVisible() ~= true then
		Primwin:FadeStart()
		end
	elseif OOCcrit == "Vitals 100%" then
		if Player:IsInCombat() == true or Vit100 == "false" then
		Primwin:SetVisible( true )
		if Bars == "Enabled" then
		MBarWin:SetVisible( true )
		MBarRail:SetVisible( true )
		PBarWin:SetVisible( true )
		PBarRail:SetVisible( true )
		end
		if Meter == "Enabled" then
		MeterWin:SetVisible( true )
		MeterRail:SetVisible( true )
		end
		if Text == "Enabled" then
		MTWin:SetVisible( true )
		PTWin:SetVisible( true )
		end
		if InterruptCD == "Enabled" then
			IntCD:SetVisible( true )
			IntCD:SetOpacity( 1 )
		end
		if CorruptionCD == "Enabled" then
			CorrCD:SetVisible( true )
			CorrCD:SetOpacity( 1 )
		end
		if PanCD == "Enabled" then
			PanicCD:SetVisible( true )
			PanicCD:SetOpacity( 1 )
		end
		if BubCD == "Enabled" then
			BubbleCD:SetVisible( true )
			BubbleCD:SetOpacity( 1 )
		end
		if Cus1CD == "Enabled" then
			C1CD:SetVisible( true )
			C1CD:SetOpacity( 1 )
		end
		if Cus2CD == "Enabled" then
			C2CD:SetVisible( true )
			C2CD:SetOpacity( 1 )
		end
		elseif Player:IsInCombat() == false and Vit100 == "true" and Primwin:IsVisible() == true and AWarnFading == "False"   and Primwin:IsVisible() == true and AWarnFading == "False" and SwindowMaster:IsVisible() ~= true then
		Primwin:FadeStart()
		end
	elseif OOCcrit == "100% Morale" then
		if Player:IsInCombat() == true or MFull == "false" then
		if Bars == "Enabled" then
		MBarWin:SetVisible( true )
		MBarRail:SetVisible( true )
		PBarWin:SetVisible( true )
		PBarRail:SetVisible( true )
		end
		if Meter == "Enabled" then
		MeterWin:SetVisible( true )
		MeterRail:SetVisible( true )
		end
		if Text == "Enabled" then
		MTWin:SetVisible( true )
		PTWin:SetVisilbe( true )
		end
		if InterruptCD == "Enabled" then
			IntCD:SetVisible( true )
			IntCD:SetOpacity( 1 )
		end
		if CorruptionCD == "Enabled" then
			CorrCD:SetVisible( true )
			CorrCD:SetOpacity( 1 )
		end
		if PanCD == "Enabled" then
			PanicCD:SetVisible( true )
			PanicCD:SetOpacity( 1 )
		end
		if BubCD == "Enabled" then
			BubbleCD:SetVisible( true )
			BubbleCD:SetOpacity( 1 )
		end
		if Cus1CD == "Enabled" then
			C1CD:SetVisible( true )
			C1CD:SetOpacity( 1 )
		end
		if Cus2CD == "Enabled" then
			C2CD:SetVisible( true )
			C2CD:SetOpacity( 1 )
		end
		elseif Player:IsInCombat() == false and MFull == "true"  and Primwin:IsVisible() == true and AWarnFading == "False"   and Primwin:IsVisible() == true and AWarnFading == "False" and SwindowMaster:IsVisible() ~= true then
		Primwin:FadeStart()
		end
	elseif OOCcrit == "100% Power" then
		if Player:IsInCombat() == true or PFull == "false" then
		if Bars == "Enabled" then
		MBarWin:SetVisible( true )
		MBarRail:SetVisible( true )
		PBarWin:SetVisible( true )
		PBarRail:SetVisible( true )
		end
		if Meter == "Enabled" then
		MeterWin:SetVisible( true )
		MeterRail:SetVisible( true )
		end
		if Text == "Enabled" then
		MTWin:SetVisible( true )
		PTWin:SetVisilbe( true )
		end
		if InterruptCD == "Enabled" then
			IntCD:SetVisible( true )
			IntCD:SetOpacity( 1 )
		end
		if CorruptionCD == "Enabled" then
			CorrCD:SetVisible( true )
			CorrCD:SetOpacity( 1 )
		end
		if PanCD == "Enabled" then
			PanicCD:SetVisible( true )
			PanicCD:SetOpacity( 1 )
		end
		if BubCD == "Enabled" then
			BubbleCD:SetVisible( true )
			BubbleCD:SetOpacity( 1 )
		end
		if Cus1CD == "Enabled" then
			C1CD:SetVisible( true )
			C1CD:SetOpacity( 1 )
		end
		if Cus2CD == "Enabled" then
			C2CD:SetVisible( true )
			C2CD:SetOpacity( 1 )
		end
		elseif Player:IsInCombat() == false and PFull == "true"  and Primwin:IsVisible() == true and AWarnFading == "False" and SwindowMaster:IsVisible() ~= true then
		Primwin:FadeStart()
		end
	end

	if PlayerClass == Turbine.Gameplay.Class.Champion then
	MeterWin:ScanFervour()
	elseif PlayerClass == Turbine.Gameplay.Class.Hunter then
	MeterWin:ScanFocus()
	elseif PlayerClass == Turbine.Gameplay.Class.RuneKeeper then
	MeterWin:ScanAttunement()
	else MeterWin:SetVisible( false )
	MeterRail:SetVisible( false )
	end
	
	--Drag sequences

	if MWarn.Dragging == "true" then
	MWarn:Drag()
	end
	if PWarn.Dragging == "true" then
	PWarn:Drag()
	end
	if DHitWarn.Dragging == "true" then
	DHitWarn:Drag()
	end
	if PanicCD.Dragging == "true" then
	PanicCD:Drag()
	end
	if BubbleCD.Dragging == "true" then
	BubbleCD:Drag()
	end
	if CorrCD.Dragging == "true" then
	CorrCD:Drag()
	end
	if IntCD.Dragging == "true" then
	IntCD:Drag()
	end
	if C1CD.Dragging == "true" then
	C1CD:Drag()
	end
	if C2CD.Dragging == "true" then
	C2CD:Drag()
	end
	if MQSG.Dragging == "true" then
	MQSG:Drag()
	end
	if PQSG.Dragging == "true" then
	PQSG:Drag()
	end
	if PoQSG.Dragging == "true" then
	PoQSG:Drag()
	end
	if FQSG.Dragging == "true" then
	FQSG:Drag()
	end
	if WQSG.Dragging == "true" then
	WQSG:Drag()
	end
	if DQSG.Dragging == "true" then
	DQSG:Drag()
	end
	if MBarWin.Dragging == "true" then
	MBarWin:Drag()
	MBarRail:SetLeft( MBarWin:GetLeft() )
	MBarRail:SetTop( MBarWin:GetTop() )
	end
	if PBarWin.Dragging == "true" then
	PBarWin:Drag()
	PBarRail:SetLeft( PBarWin:GetLeft() )
	PBarRail:SetTop( PBarWin:GetTop() )
	end
	if MTWin.Dragging == "true" then
	MTWin:Drag()
	end
	if PTWin.Dragging == "true" then
	PTWin:Drag()
	end
	if TTWin.Dragging == "true" then
	TTWin:Drag()
	end
	if MeterWin.Dragging == "true" then
	MeterWin:Drag()
	MeterRail:SetLeft( MeterWin:GetLeft() )
	MeterRail:SetTop( MeterWin:GetTop() )
	end

	if FrameTime <= Fadetime and LFading == "True" then
		Primwin:SetVisible( true )
		Primwin:SetOpacity( 1 )
		if quickslots == "Enabled" then
			MQS:SetVisible( true )
			PQS:SetVisible( true )
			DQS:SetVisible( true )
			WQS:SetVisible( true )
			PoQS:SetVisible( true )
			FQS:SetVisible( true )
			MQSG:SetVisible( true )
			PQSG:SetVisible( true )
			DQSG:SetVisible( true )
			WQSG:SetVisible( true )
			PoQSG:SetVisible( true )
			FQSG:SetVisible( true )
		end
		if Bars == "Enabled" then
			MBar:SetVisible( true )
			MBarWin:SetVisible( true )
			PBarWin:SetVisible( true )
			PBar:SetVisible( true )
			MBarRail:SetVisible( true )
			PBarRail:SetVisible( true )
			MBarWin:SetOpacity( BopT )
			MBarRail:SetOpacity( BopT )
			PBarWin:SetOpacity( BopT )
			PBarWin:SetOpacity( BopT )
		end
		if Meter == "Enabled" then
			MeterBar:SetVisible( true )
			MeterWin:SetVisible( true )
			MeterRail:SetVisible( true )
			MeterWin:SetOpacity( MopT )
			MeterRail:SetOpacity( MopT )
		end
		if Moralewarn == "Enabled" then
			MWarn:SetVisible( true )
			MWarn:SetOpacity( MWopT )
		end
		if Powerwarn == "Enabled" then
			PWarn:SetVisible( true )
			PWarn:SetOpacity( PWopT )
		end
		if DHitWarning == "Enabled" then
			DHitWarn:SetVisible( true )
			DHitWarn:SetOpacity( DHopT )
		end
		if InterruptCD == "Enabled" then
			IntCD:SetVisible( true )
			IntCD:SetOpacity( 1 )
		end
		if CorruptionCD == "Enabled" then
			CorrCD:SetVisible( true )
			CorrCD:SetOpacity( 1 )
		end
		if PanCD == "Enabled" then
			PanicCD:SetVisible( true )
			PanicCD:SetOpacity( 1 )
		end
		if BubCD == "Enabled" then
			BubbleCD:SetVisible( true )
			BubbleCD:SetOpacity( 1 )
		end
		if Cus1CD == "Enabled" then
			C1CD:SetVisible( true )
			C1CD:SetOpacity( 1 )
		end
		if Cus2CD == "Enabled" then
			C2CD:SetVisible( true )
			C2CD:SetOpacity( 1 )
		end
		if Text == "Enabled" then
			MTWin:SetVisible( true )
			MTWin:SetOpacity( 1 )
			PTWin:SetVisible( true )
			PTWin:SetOpacity( 1 )
		end
	elseif FrameTime >= Fadetime and LFading == "True" then
			Primwin:FadeStart()
			LFading = "False"
			DHitWarn:FadeStart()
	end	
	if HUDVis == "False" then
	Primwin:SetOpacity( 0 )
	PanicCD:SetOpacity( 0 )
	BubbleCD:SetOpacity( 0 )
	CorrCD:SetOpacity( 0 )
	IntCD:SetOpacity( 0 )
	C1CD:SetOpacity( 0 )
	C2CD:SetOpacity( 0 )
	MBarWin:SetOpacity( 0 )
	PBarWin:SetOpacity( 0 )
	MBarRail:SetOpacity( 0 )
	PBarRail:SetOpacity( 0 )
	MeterWin:SetOpacity( 0 )
	MeterRail:SetOpacity( 0 )
	MWarn:SetOpacity( 0 )
	PWarn:SetOpacity( 0 )
	DHitWarn:SetOpacity( 0 )
	SwindowMaster:SetOpacity( 0 )
	MTWin:SetOpacity( 0 )
	TTWin:SetOpacity( 0 )
	PTWin:SetOpacity( 0 )
	MQS:SetVisible( false )
	PQS:SetVisible( false )
	WQS:SetVisible( false )
	PoQS:SetVisible( false )
	FQS:SetVisible( false )
	DQS:SetVisible( false )
	MQSG:SetVisible( false )
	PQSG:SetVisible( false )
	WQSG:SetVisible( false )
	PoQSG:SetVisible( false )
	FQSG:SetVisible( false )
	DQSG:SetVisible( false )
	end
end

function Primwin:KeyDown(args)
	if args.Action == 268435635 and HUDVis == "False" then
	HUDVis = "True"
	elseif args.Action == 268435635 and HUDVis == "True" then
	HUDVis = "False"
	end
end

Recenterbutton = Turbine.UI.Lotro.Button();
Recenterbutton:SetSize( 80, 30 );
Recenterbutton:SetText( "Recenter" );
Recenterbutton:SetVisible( true );
Recenterbutton:SetParent( Swindow );
Recenterbutton:SetPosition( 370, 760 );
Recenterbutton.MouseClick = function()
	Primwin:RecenterControls()
end

import "CajePlugins.HUDPlus.OptionsMain"